/* ////////////////////////////////////////////////////////////

File Name: writetownsfd.cpp
Copyright (c) 2018 Soji Yamakawa.  All rights reserved.
http://www.ysflight.com

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//////////////////////////////////////////////////////////// */

#include <windows.h>
#include <fileapi.h>
#include <stdio.h>

#include <vector>
#include <string>

#include "ioutil.h"


int main(int ac,char *av[])
{
	if(ac<3)
	{
		printf("Usage: writetownsfd drive-letter disk-image\n");
		return 1;
	}


	if('a'!=av[1][0] && 'A'!=av[1][0] && 'b'!=av[1][0] && 'B'!=av[1][0])
	{
		printf("Drive letter is limited to A or B for not to destroy hard drives.\n");
		return 1;
	}

	auto bin=ReadBinaryFile(av[2]);
	if(0==bin.size())
	{
		printf("Failed to open disk image.\n");
		return 1;
	}

	if(1261568==bin.size())
	{
		printf("FM-TOWNS format 2HD disk image.\n");
		printf("  1.23MB  1024bytes-per-sector  8sectors-per-track  2sides  77tracks\n");
	}
	else
	{
		printf("Image file needs to be 1261568 bytes.\n");
		return 1;
	}


	Win32FloppyDisk disk;
	disk.OpenForWrite(av[1][0]);
	if(1261568==bin.size())
	{
		long long int bytePerTrack=1024*8*2;
		for(long long int track=0; track<77; ++track)
		{
			printf("Writing Track %lld\n",track);
			auto offset=track*bytePerTrack;
			disk.WriteImage(bytePerTrack,bin.data()+offset);
		}
	}
	disk.Close();

	return 0;
}
